---
title: Document.createElementNS()
slug: Web/API/Document/createElementNS
tags:
  - API
  - DOM
  - Method
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>Creates an element with the specified namespace URI and qualified name.</p>

<p>To create an element without specifying a namespace URI, use the {{DOMxRef("Document.createElement()", "createElement()")}} method.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>var element</var> = <var>document</var>.createElementNS(<var>namespaceURI</var>, <var>qualifiedName</var>[, <var>options</var>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><var>namespaceURI</var></dt>
 <dd>A string that specifies the <a class="external" href="http://www.w3.org/TR/2004/REC-DOM-Level-3-Core-20040407/glossary.html#dt-namespaceURI">namespace URI</a> to associate with the element. The {{DOMxRef("element.namespaceURI", "namespaceURI")}} property of the created element is initialized with the value of <var>namespaceURI</var>. See <a href="#Important_Namespace_URIs">Valid Namespace URIs</a>.</dd>
 <dt><var>qualifiedName</var></dt>
 <dd>A string that specifies the type of element to be created. The {{DOMxRef("element.nodeName", "nodeName")}} property of the created element is initialized with the value of <var>qualifiedName</var>.</dd>
 <dt><var>options</var>{{Optional_Inline}}</dt>
 <dd>An optional <code>ElementCreationOptions</code> object containing a single property named <code>is</code>, whose value is the tag name for a custom element previously defined using <code>customElements.define()</code>. For backwards compatibility with previous versions of the <a class="external external-icon" href="https://www.w3.org/TR/custom-elements/">Custom Elements specification</a>, some browsers will allow you to pass a string here instead of an object, where the string's value is the custom element's tag name. See <a class="external external-icon" href="https://developers.google.com/web/fundamentals/primers/customelements/#extendhtml">Extending native HTML elements</a> for more information on how to use this parameter.</dd>
 <dd>The new element will be given an <code>is</code> attribute whose value is the custom element's tag name. Custom elements are an experimental feature only available in some browsers.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The new {{DOMxRef("Element")}}.</p>

<h2 id="Important_Namespace_URIs">Important Namespace URIs</h2>

<dl>
 <dt><a href="/en-US/docs/Web/HTML">HTML</a></dt>
 <dd><code>http://www.w3.org/1999/xhtml</code></dd>
 <dt><a href="/en-US/docs/Web/SVG">SVG</a></dt>
 <dd><code>http://www.w3.org/2000/svg</code></dd>
 <dt><a href="/en-US/docs/Web/MathML">MathML</a></dt>
 <dd><code>http://www.w3.org/1998/Math/MathML</code></dd>
 <dt><a href="/en-US/docs/Mozilla/Tech/XUL">XUL</a> {{Non-standard_Inline}}</dt>
 <dd><code>http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul</code></dd>
 <dt><a href="/en-US/docs/Mozilla/Tech/XBL">XBL</a> {{Non-standard_Inline}} {{Deprecated_Inline}}</dt>
 <dd><code>http://www.mozilla.org/xbl</code></dd>
</dl>

<h2 id="Example">Example</h2>

<p>This creates a new &lt;div&gt; element in the {{Glossary("XHTML")}} namespace and appends it to the vbox element. Although this is not an extremely useful <a href="/en-US/docs/Mozilla/Tech/XUL">XUL</a> document, it does demonstrate the use of elements from two different namespaces within a single document:</p>

<pre class="brush: xml">&lt;?xml version="1.0"?&gt;
&lt;page xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
      xmlns:html="http://www.w3.org/1999/xhtml"
      title="||Working with elements||"
      onload="init()"&gt;

&lt;script type="application/javascript"&gt;&lt;![CDATA[
 let container;
 let newdiv;
 let txtnode;

 function init(){
   container = document.getElementById("ContainerBox");
   newdiv = document.createElementNS("http://www.w3.org/1999/xhtml", "div");
   txtnode = document.createTextNode("This is text that was constructed dynamically with createElementNS and createTextNode then inserted into the document using appendChild.");
   newdiv.appendChild(txtnode);
   container.appendChild(newdiv);
 }

]]&gt;&lt;/script&gt;

 &lt;vbox id="ContainerBox" flex="1"&gt;
  &lt;html:div&gt;
   The script on this page will add dynamic content below:
  &lt;/html:div&gt;
 &lt;/vbox&gt;

&lt;/page&gt;
</pre>

<div class="notecard note">
<p>The example given above uses inline script which is not recommended in XHTML documents. This particular example is actually an XUL document with embedded XHTML, however, the recommendation still applies.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-document-createelementns", "Document.createElementNS()")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.createElementNS")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("document.createElement()")}}</li>
 <li>{{DOMxRef("document.createTextNode()")}}</li>
 <li>{{DOMxRef("Node.namespaceURI")}}</li>
 <li><a class="external" href="http://www.w3.org/TR/1999/REC-xml-names-19990114">Namespaces in XML</a></li>
</ul>
